import { ChangeDetectionStrategy, Component, Input, TemplateRef, ViewChild, ViewEncapsulation, ContentChild, ContentChildren, ElementRef, EventEmitter, HostListener, Output, Renderer2, NgModule } from '@angular/core';
import { MatTabGroup, MatButtonModule, MatCardModule, MatIconModule, MatSidenavModule, MatStepperModule, MatTabsModule, MatToolbarModule } from '@angular/material';
import { CommonModule } from '@angular/common';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,uselessCode} checked by tsc
 */
class MatPageOutlookComponent {
    constructor() {
    }
    /**
     * @return {?}
     */
    ngOnInit() {
    }
}
MatPageOutlookComponent.decorators = [
    { type: Component, args: [{
                selector: 'mat-page-outlook',
                template: `
    <ng-template>
      <ng-content></ng-content>
    </ng-template>
  `,
                styles: [`

  `],
                encapsulation: ViewEncapsulation.None,
                changeDetection: ChangeDetectionStrategy.OnPush,
            },] },
];
/** @nocollapse */
MatPageOutlookComponent.ctorParameters = () => [];
MatPageOutlookComponent.propDecorators = {
    content: [{ type: ViewChild, args: [TemplateRef,] }],
    title: [{ type: Input }]
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,uselessCode} checked by tsc
 */
class MatPageContentComponent {
    constructor() {
    }
    /**
     * @return {?}
     */
    ngOnInit() {
    }
}
MatPageContentComponent.decorators = [
    { type: Component, args: [{
                selector: 'mat-page-content',
                template: `
    <ng-template>
      <mat-card style="margin: 2rem">
        <mat-card-title>{{title}}</mat-card-title>
        <mat-card-content>
          <ng-content></ng-content>
        </mat-card-content>
      </mat-card>
    </ng-template>
  `,
                styles: [`

  `],
            },] },
];
/** @nocollapse */
MatPageContentComponent.ctorParameters = () => [];
MatPageContentComponent.propDecorators = {
    content: [{ type: ViewChild, args: [TemplateRef,] }],
    title: [{ type: Input }]
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,uselessCode} checked by tsc
 */
class MatPageLoaderComponent {
}
MatPageLoaderComponent.decorators = [
    { type: Component, args: [{
                selector: 'mat-page-loader',
                template: `

  `,
                styles: [`

  `]
            },] },
];
MatPageLoaderComponent.propDecorators = {
    pageOutlook: [{ type: ContentChild, args: [MatPageOutlookComponent,] }],
    pageContent: [{ type: ContentChild, args: [MatPageContentComponent,] }]
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,uselessCode} checked by tsc
 */
class MatPagesComponent {
    /**
     * @param {?} renderer
     */
    constructor(renderer) {
        this.renderer = renderer;
        this.done = new EventEmitter();
        this.pageChanged = new EventEmitter();
        // the mode of the sidenav
        this.navMode = 'side';
        this.index = 0;
    }
    /**
     * @return {?}
     */
    _initSidenavMode() {
        if (window.innerWidth < 768) {
            this.navMode = 'over';
        }
    }
    /**
     * @return {?}
     */
    ngOnInit() {
        this._initSidenavMode();
    }
    /**
     * @return {?}
     */
    ngAfterContentInit() {
        this.totalPages = this.pages.length;
        this.renderer.setStyle(this.tabHeader.nativeElement.children[0], 'display', 'none');
    }
    /**
     * @param {?} event
     * @return {?}
     */
    onResize(event) {
        if (event.target.innerWidth < 768) {
            this.navMode = 'over';
            this.sidenav.close();
        }
        if (event.target.innerWidth > 768) {
            this.navMode = 'side';
            this.sidenav.open();
        }
    }
    /**
     * Go to the previous page if it exists
     * @return {?}
     */
    previous() {
        this.index = this.index === 0 ? 0 : --this.index;
        this.pageChanged.emit(this.index);
    }
    /**
     * Go to the next page if it exists
     * @return {?}
     */
    next() {
        this.index = this.index === this.totalPages - 1 ? this.totalPages - 1 : ++this.index;
        this.pageChanged.emit(this.index);
        if (this.index === this.totalPages - 1) {
            this.done.emit();
        }
    }
    /**
     * Update the value of the index when a step has been selected.
     * Emit this value for pagechanged's subscribers.
     *
     * @param {?} event
     * @return {?}
     */
    onStepSelectionChange(event) {
        this.index = event.selectedIndex;
        this.pageChanged.emit(this.index);
    }
}
MatPagesComponent.decorators = [
    { type: Component, args: [{
                selector: 'mat-pages',
                template: `
    <mat-sidenav-container>
      <mat-sidenav #sidenav [mode]="navMode" opened="true"
                   [fixedInViewport]="'false'" [fixedTopGap]="'false'" [fixedBottomGap]="'false'">

        <mat-toolbar color="primary">
        </mat-toolbar>

        <mat-vertical-stepper [selectedIndex]="index" (selectionChange)="onStepSelectionChange($event)">
          <mat-step *ngFor="let page of pages;let i = index;" [label]="page.pageOutlook.title">
            <ng-container [ngTemplateOutlet]="page.pageOutlook.content"></ng-container>
          </mat-step>
        </mat-vertical-stepper>
      </mat-sidenav>

      <mat-sidenav-content>
        <mat-toolbar color="primary">
          <button mat-icon-button (click)="sidenav.toggle()">
            <mat-icon>menu</mat-icon>
          </button>
          {{title}}
        </mat-toolbar>
        <div class="demo-sidenav-content main-container">

          <mat-tab-group [selectedIndex]="index" style="min-height: 15vh;" >
            <button mat-fab color="warn" (click)="previous()">
              <mat-icon>location</mat-icon>
            </button>
            <mat-tab *ngFor="let page of pages;let i = index;">
              <ng-template matTabContent>
                <ng-container [ngTemplateOutlet]="page.pageContent.content"></ng-container>
              </ng-template>
            </mat-tab>
          </mat-tab-group>


          <div class="navigation-buttons">
            <button mat-fab color="primary" (click)="previous()" [disabled]="index == 0">
              <mat-icon>chevron_left</mat-icon>
            </button>
            <div *ngIf="index == totalPages - 1;then finished else nextAvailable">
            </div>
            <ng-template #nextAvailable>
              <button mat-fab color="primary" (click)="next()">
                <mat-icon>chevron_right</mat-icon>
              </button>
            </ng-template>
            <ng-template #finished>
              <button mat-fab color="accent" (click)="done.next()">
                <mat-icon>done</mat-icon>
              </button>
            </ng-template>
          </div>

        </div>
      </mat-sidenav-content>
    </mat-sidenav-container>
  `,
                styles: [`
    .navigation-buttons{margin:1rem;place-content:stretch space-between;align-items:stretch;flex-direction:row;box-sizing:border-box;display:flex}
  `]
            },] },
];
/** @nocollapse */
MatPagesComponent.ctorParameters = () => [
    { type: Renderer2 }
];
MatPagesComponent.propDecorators = {
    sidenav: [{ type: ViewChild, args: ['sidenav',] }],
    tabHeader: [{ type: ViewChild, args: [MatTabGroup, { read: ElementRef },] }],
    pages: [{ type: ContentChildren, args: [MatPageLoaderComponent,] }],
    title: [{ type: Input }],
    done: [{ type: Output }],
    pageChanged: [{ type: Output }],
    onResize: [{ type: HostListener, args: ['window:resize', ['$event'],] }]
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,uselessCode} checked by tsc
 */
class MatPagesModule {
    /**
     * @return {?}
     */
    static forRoot() {
        return {
            ngModule: MatPagesModule,
            providers: []
        };
    }
}
MatPagesModule.decorators = [
    { type: NgModule, args: [{
                imports: [
                    CommonModule,
                    MatToolbarModule,
                    MatTabsModule,
                    MatCardModule,
                    MatSidenavModule,
                    MatIconModule,
                    MatStepperModule,
                    MatButtonModule
                ],
                exports: [
                    MatPagesComponent,
                    MatPageLoaderComponent,
                    MatPageOutlookComponent,
                    MatPageContentComponent
                ],
                declarations: [
                    MatPagesComponent,
                    MatPageLoaderComponent,
                    MatPageOutlookComponent,
                    MatPageContentComponent
                ]
            },] },
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,uselessCode} checked by tsc
 */

export { MatPagesComponent, MatPageLoaderComponent, MatPageOutlookComponent, MatPageContentComponent, MatPagesModule };
//# sourceMappingURL=pages.js.map
