import { ChangeDetectionStrategy, Component, Input, TemplateRef, ViewChild, ViewEncapsulation, ContentChild, ContentChildren, ElementRef, EventEmitter, HostListener, Output, Renderer2, NgModule } from '@angular/core';
import { MatTabGroup, MatButtonModule, MatCardModule, MatIconModule, MatSidenavModule, MatStepperModule, MatTabsModule, MatToolbarModule } from '@angular/material';
import { CommonModule } from '@angular/common';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,uselessCode} checked by tsc
 */
var MatPageOutlookComponent = /** @class */ (function () {
    function MatPageOutlookComponent() {
    }
    /**
     * @return {?}
     */
    MatPageOutlookComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
    };
    MatPageOutlookComponent.decorators = [
        { type: Component, args: [{
                    selector: 'mat-page-outlook',
                    template: "\n    <ng-template>\n      <ng-content></ng-content>\n    </ng-template>\n  ",
                    styles: ["\n\n  "],
                    encapsulation: ViewEncapsulation.None,
                    changeDetection: ChangeDetectionStrategy.OnPush,
                },] },
    ];
    /** @nocollapse */
    MatPageOutlookComponent.ctorParameters = function () { return []; };
    MatPageOutlookComponent.propDecorators = {
        content: [{ type: ViewChild, args: [TemplateRef,] }],
        title: [{ type: Input }]
    };
    return MatPageOutlookComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,uselessCode} checked by tsc
 */
var MatPageContentComponent = /** @class */ (function () {
    function MatPageContentComponent() {
    }
    /**
     * @return {?}
     */
    MatPageContentComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
    };
    MatPageContentComponent.decorators = [
        { type: Component, args: [{
                    selector: 'mat-page-content',
                    template: "\n    <ng-template>\n      <mat-card style=\"margin: 2rem\">\n        <mat-card-title>{{title}}</mat-card-title>\n        <mat-card-content>\n          <ng-content></ng-content>\n        </mat-card-content>\n      </mat-card>\n    </ng-template>\n  ",
                    styles: ["\n\n  "],
                },] },
    ];
    /** @nocollapse */
    MatPageContentComponent.ctorParameters = function () { return []; };
    MatPageContentComponent.propDecorators = {
        content: [{ type: ViewChild, args: [TemplateRef,] }],
        title: [{ type: Input }]
    };
    return MatPageContentComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,uselessCode} checked by tsc
 */
var MatPageLoaderComponent = /** @class */ (function () {
    function MatPageLoaderComponent() {
    }
    MatPageLoaderComponent.decorators = [
        { type: Component, args: [{
                    selector: 'mat-page-loader',
                    template: "\n\n  ",
                    styles: ["\n\n  "]
                },] },
    ];
    MatPageLoaderComponent.propDecorators = {
        pageOutlook: [{ type: ContentChild, args: [MatPageOutlookComponent,] }],
        pageContent: [{ type: ContentChild, args: [MatPageContentComponent,] }]
    };
    return MatPageLoaderComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,uselessCode} checked by tsc
 */
var MatPagesComponent = /** @class */ (function () {
    function MatPagesComponent(renderer) {
        this.renderer = renderer;
        this.done = new EventEmitter();
        this.pageChanged = new EventEmitter();
        // the mode of the sidenav
        this.navMode = 'side';
        this.index = 0;
    }
    /**
     * @return {?}
     */
    MatPagesComponent.prototype._initSidenavMode = /**
     * @return {?}
     */
    function () {
        if (window.innerWidth < 768) {
            this.navMode = 'over';
        }
    };
    /**
     * @return {?}
     */
    MatPagesComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        this._initSidenavMode();
    };
    /**
     * @return {?}
     */
    MatPagesComponent.prototype.ngAfterContentInit = /**
     * @return {?}
     */
    function () {
        this.totalPages = this.pages.length;
        this.renderer.setStyle(this.tabHeader.nativeElement.children[0], 'display', 'none');
    };
    /**
     * @param {?} event
     * @return {?}
     */
    MatPagesComponent.prototype.onResize = /**
     * @param {?} event
     * @return {?}
     */
    function (event) {
        if (event.target.innerWidth < 768) {
            this.navMode = 'over';
            this.sidenav.close();
        }
        if (event.target.innerWidth > 768) {
            this.navMode = 'side';
            this.sidenav.open();
        }
    };
    /**
     * Go to the previous page if it exists
     */
    /**
     * Go to the previous page if it exists
     * @return {?}
     */
    MatPagesComponent.prototype.previous = /**
     * Go to the previous page if it exists
     * @return {?}
     */
    function () {
        this.index = this.index === 0 ? 0 : --this.index;
        this.pageChanged.emit(this.index);
    };
    /**
     * Go to the next page if it exists
     */
    /**
     * Go to the next page if it exists
     * @return {?}
     */
    MatPagesComponent.prototype.next = /**
     * Go to the next page if it exists
     * @return {?}
     */
    function () {
        this.index = this.index === this.totalPages - 1 ? this.totalPages - 1 : ++this.index;
        this.pageChanged.emit(this.index);
        if (this.index === this.totalPages - 1) {
            this.done.emit();
        }
    };
    /**
     * Update the value of the index when a step has been selected.
     * Emit this value for pagechanged's subscribers.
     *
     */
    /**
     * Update the value of the index when a step has been selected.
     * Emit this value for pagechanged's subscribers.
     *
     * @param {?} event
     * @return {?}
     */
    MatPagesComponent.prototype.onStepSelectionChange = /**
     * Update the value of the index when a step has been selected.
     * Emit this value for pagechanged's subscribers.
     *
     * @param {?} event
     * @return {?}
     */
    function (event) {
        this.index = event.selectedIndex;
        this.pageChanged.emit(this.index);
    };
    MatPagesComponent.decorators = [
        { type: Component, args: [{
                    selector: 'mat-pages',
                    template: "\n    <mat-sidenav-container>\n      <mat-sidenav #sidenav [mode]=\"navMode\" opened=\"true\"\n                   [fixedInViewport]=\"'false'\" [fixedTopGap]=\"'false'\" [fixedBottomGap]=\"'false'\">\n\n        <mat-toolbar color=\"primary\">\n        </mat-toolbar>\n\n        <mat-vertical-stepper [selectedIndex]=\"index\" (selectionChange)=\"onStepSelectionChange($event)\">\n          <mat-step *ngFor=\"let page of pages;let i = index;\" [label]=\"page.pageOutlook.title\">\n            <ng-container [ngTemplateOutlet]=\"page.pageOutlook.content\"></ng-container>\n          </mat-step>\n        </mat-vertical-stepper>\n      </mat-sidenav>\n\n      <mat-sidenav-content>\n        <mat-toolbar color=\"primary\">\n          <button mat-icon-button (click)=\"sidenav.toggle()\">\n            <mat-icon>menu</mat-icon>\n          </button>\n          {{title}}\n        </mat-toolbar>\n        <div class=\"demo-sidenav-content main-container\">\n\n          <mat-tab-group [selectedIndex]=\"index\" style=\"min-height: 15vh;\" >\n            <button mat-fab color=\"warn\" (click)=\"previous()\">\n              <mat-icon>location</mat-icon>\n            </button>\n            <mat-tab *ngFor=\"let page of pages;let i = index;\">\n              <ng-template matTabContent>\n                <ng-container [ngTemplateOutlet]=\"page.pageContent.content\"></ng-container>\n              </ng-template>\n            </mat-tab>\n          </mat-tab-group>\n\n\n          <div class=\"navigation-buttons\">\n            <button mat-fab color=\"primary\" (click)=\"previous()\" [disabled]=\"index == 0\">\n              <mat-icon>chevron_left</mat-icon>\n            </button>\n            <div *ngIf=\"index == totalPages - 1;then finished else nextAvailable\">\n            </div>\n            <ng-template #nextAvailable>\n              <button mat-fab color=\"primary\" (click)=\"next()\">\n                <mat-icon>chevron_right</mat-icon>\n              </button>\n            </ng-template>\n            <ng-template #finished>\n              <button mat-fab color=\"accent\" (click)=\"done.next()\">\n                <mat-icon>done</mat-icon>\n              </button>\n            </ng-template>\n          </div>\n\n        </div>\n      </mat-sidenav-content>\n    </mat-sidenav-container>\n  ",
                    styles: ["\n    .navigation-buttons{margin:1rem;place-content:stretch space-between;align-items:stretch;flex-direction:row;box-sizing:border-box;display:flex}\n  "]
                },] },
    ];
    /** @nocollapse */
    MatPagesComponent.ctorParameters = function () { return [
        { type: Renderer2 }
    ]; };
    MatPagesComponent.propDecorators = {
        sidenav: [{ type: ViewChild, args: ['sidenav',] }],
        tabHeader: [{ type: ViewChild, args: [MatTabGroup, { read: ElementRef },] }],
        pages: [{ type: ContentChildren, args: [MatPageLoaderComponent,] }],
        title: [{ type: Input }],
        done: [{ type: Output }],
        pageChanged: [{ type: Output }],
        onResize: [{ type: HostListener, args: ['window:resize', ['$event'],] }]
    };
    return MatPagesComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,uselessCode} checked by tsc
 */
var MatPagesModule = /** @class */ (function () {
    function MatPagesModule() {
    }
    /**
     * @return {?}
     */
    MatPagesModule.forRoot = /**
     * @return {?}
     */
    function () {
        return {
            ngModule: MatPagesModule,
            providers: []
        };
    };
    MatPagesModule.decorators = [
        { type: NgModule, args: [{
                    imports: [
                        CommonModule,
                        MatToolbarModule,
                        MatTabsModule,
                        MatCardModule,
                        MatSidenavModule,
                        MatIconModule,
                        MatStepperModule,
                        MatButtonModule
                    ],
                    exports: [
                        MatPagesComponent,
                        MatPageLoaderComponent,
                        MatPageOutlookComponent,
                        MatPageContentComponent
                    ],
                    declarations: [
                        MatPagesComponent,
                        MatPageLoaderComponent,
                        MatPageOutlookComponent,
                        MatPageContentComponent
                    ]
                },] },
    ];
    return MatPagesModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,uselessCode} checked by tsc
 */

export { MatPagesComponent, MatPageLoaderComponent, MatPageOutlookComponent, MatPageContentComponent, MatPagesModule };
//# sourceMappingURL=pages.es5.js.map
