import { AfterContentInit, ElementRef, EventEmitter, OnInit, QueryList, Renderer2 } from '@angular/core';
import { MatPageLoaderComponent } from './mat-page-loader/mat-page-loader.component';
import { StepperSelectionEvent } from '@angular/cdk/stepper';
import { MatSidenav } from '@angular/material';
export declare class MatPagesComponent implements OnInit, AfterContentInit {
    private renderer;
    sidenav: MatSidenav;
    tabHeader: ElementRef;
    pages: QueryList<MatPageLoaderComponent>;
    title: string;
    done: EventEmitter<void>;
    pageChanged: EventEmitter<number>;
    navMode: string;
    index: number;
    totalPages: number;
    constructor(renderer: Renderer2);
    private _initSidenavMode;
    ngOnInit(): void;
    ngAfterContentInit(): void;
    onResize(event: any): void;
    /**
     * Go to the previous page if it exists
     */
    previous(): void;
    /**
     * Go to the next page if it exists
     */
    next(): void;
    /**
     * Update the value of the index when a step has been selected.
     * Emit this value for pagechanged's subscribers.
     *
     */
    onStepSelectionChange(event: StepperSelectionEvent): void;
}
